Package org.eclipse.cdt.core

## Class CCorePreferenceConstants

- java.lang.Object
- - org.eclipse.cdt.core.CCorePreferenceConstants

    public class CCorePreferenceConstants
    extends Object

Restriction:
  This class is not intended to be subclassed by clients.
Restriction:
  This class is not intended to be instantiated by clients.

### Field Summary

Fields
`static String` `ADD_OVERRIDE_KEYWORD` A named preference that specifies whether the override keyword should be added to method signature.
`static String` `CODE_FORMATTER` Active code formatter ID.
`static boolean` `DEFAULT_ADD_OVERRIDE_KEYWORD` Default value for `ADD_OVERRIDE_KEYWORD`.
`static String` `DEFAULT_CODE_FORMATTER` Default code formatter
`static String` `DEFAULT_INCLUDE_BEGIN_EXPORTS_PATTERN` Default value for `INCLUDE_BEGIN_EXPORTS_PATTERN`.
`static String` `DEFAULT_INCLUDE_END_EXPORTS_PATTERN` Default value for `INCLUDE_END_EXPORTS_PATTERN`.
`static String` `DEFAULT_INCLUDE_EXPORT_PATTERN` Default value for `INCLUDE_EXPORT_PATTERN`.
`static String` `DEFAULT_INCLUDE_KEEP_PATTERN` Default value for `INCLUDE_KEEP_PATTERN`.
`static String` `DEFAULT_INCLUDE_PRIVATE_PATTERN` Default value for `INCLUDE_PRIVATE_PATTERN`.
`static String` `DEFAULT_INDEX_DB_CACHE_SIZE_PCT` Default cache size of the index-db in percentage of max memory.
`static String` `DEFAULT_MAX_INDEX_DB_CACHE_SIZE_MB` Default absolute maximum size of the index-db in megabytes.
`static boolean` `DEFAULT_PLACE_CONST_RIGHT_OF_TYPE` Default value for `PLACE_CONST_RIGHT_OF_TYPE`.
`static boolean` `DEFAULT_PRESERVE_VIRTUAL_KEYWORD` Default value for `PRESERVE_VIRTUAL_KEYWORD`.
`static boolean` `DEFAULT_SCALABILITY_LIMIT_TOKENS_PER_TU` Default value for `SCALABILITY_LIMIT_TOKENS_PER_TU`.
`static int` `DEFAULT_SCALABILITY_MAXIMUM_TOKENS` Default value for `SCALABILITY_MAXIMUM_TOKENS`.
`static int` `DEFAULT_SCALABILITY_MAXIMUM_TRIVIAL_EXPRESSIONS` Default value for `SCALABILITY_MAXIMUM_TRIVIAL_EXPRESSIONS`.
`static boolean` `DEFAULT_SCALABILITY_SKIP_TRIVIAL_EXPRESSIONS` Default value for `SCALABILITY_SKIP_TRIVIAL_EXPRESSIONS`.
`static String` `DEFAULT_TASK_CASE_SENSITIVE` Default case sensitivity of task tags.
`static String` `DEFAULT_TASK_PRIORITY` Default task priority
`static String` `DEFAULT_TASK_TAG` Default task tag
`static String` `DEFAULT_TASK_TAGS` List of tags provided by default
`static String` `DEFAULT_WORKSPACE_LANGUAGE_MAPPINGS` Default workspace-wide language mappings.
`static String` `FILE_PATH_CANONICALIZATION` Boolean preference controlling whether paths of non-workspace files are stored in index in canonical form or not.
`static String` `INCLUDE_BEGIN_EXPORTS_PATTERN` Preference key for the regular expression pattern that, when appears in a comment, marks the beginning of a sequence of include statements that export the included header files.
`static String` `INCLUDE_END_EXPORTS_PATTERN` Preference key for the regular expression pattern that, when appears in a comment, marks the end of a sequence of include statements that export the included header files.
`static String` `INCLUDE_EXPORT_PATTERN` Preference key for the regular expression pattern that, when appears in a comment on the same line as include statement, indicates that the included header file is exported.
`static String` `INCLUDE_KEEP_PATTERN` Preference key for the regular expression pattern that, when appears in a comment on the same line as include statement, indicates that the include statement should be preserved when organizing includes.
`static String` `INCLUDE_PRIVATE_PATTERN` Preference key for the regular expression pattern that, when appears in a comment on the same line as include statement, indicates that the included header file is private and that another header file should be included instead.
`static String` `INDEX_DB_CACHE_SIZE_PCT` Cache size for the index in percentage of max memory.
`static String` `MAX_INDEX_DB_CACHE_SIZE_MB` Absolute maximum size of the index-db in megabytes.
`static String` `PLACE_CONST_RIGHT_OF_TYPE` A named preference that specifies whether the const qualifier is written to the right (or left) of the type in a declaration specifier.
`static String` `PREF_BUILD_ALL_CONFIGS` "Build All Configurations" preference key.
`static String` `PREF_BUILD_CONFIGS_RESOURCE_CHANGES` Preference key for "build only if resources in (related) projects are modified".
`static String` `PRESERVE_VIRTUAL_KEYWORD` A named preference that specifies whether the virtual keyword should be added to method signature.
`static String` `SCALABILITY_LIMIT_TOKENS_PER_TU` A named preference that specifies whether the parser should abort when too many Tokens are created during parse of a single TU.
`static String` `SCALABILITY_MAXIMUM_TOKENS` A named preference that specifies the parser's token limit.
`static String` `SCALABILITY_MAXIMUM_TRIVIAL_EXPRESSIONS` The maximum number of trivial expressions that are parsed in initializer lists.
`static String` `SCALABILITY_SKIP_TRIVIAL_EXPRESSIONS` A named preference that controls whether the parser should skip trivial expressions in initializer lists.
`static String` `SHOW_SOURCE_FILES_IN_BINARIES` Attempt to show source files for executable binaries.
`static String` `SHOW_SOURCE_NOT_FOUND_EDITOR` Attempt to (not) show c source not found editor in debug.
`static String` `SHOW_SOURCE_NOT_FOUND_EDITOR_ALL_THE_TIME` Use to display all the time the source not found editor
`static String` `SHOW_SOURCE_NOT_FOUND_EDITOR_DEFAULT` Use to display by default the source not found editor
`static String` `SHOW_SOURCE_NOT_FOUND_EDITOR_NEVER` Use to don't display the source not found editor
`static String` `SHOW_SOURCE_NOT_FOUND_EDITOR_SOMETIMES` Use to display sometimes the source not found editor
`static String` `SHOW_SOURCE_ROOTS_AT_TOP_LEVEL_OF_PROJECT` Show source roots at the top level of projects.
`static String` `TASK_PRIORITY_HIGH` Possible configurable option value for TODO_TASK_PRIORITIES.
`static String` `TASK_PRIORITY_LOW` Possible configurable option value for TODO_TASK_PRIORITIES.
`static String` `TASK_PRIORITY_NORMAL` Possible configurable option value for TODO_TASK_PRIORITIES.
`static String` `TODO_TASK_CASE_SENSITIVE` Case sensitivity of task tags.
`static String` `TODO_TASK_PRIORITIES` Priorities associated with task tags.
`static String` `TODO_TASK_TAGS` Task tags used in code comments.
`static String` `WORKSPACE_LANGUAGE_MAPPINGS` Workspace-wide language mappings.

### Constructor Summary

Constructors
`CCorePreferenceConstants()`

### Method Summary

All Methods Static Methods Concrete Methods
`static String` `getPreference​(String key, ICProject project)` Returns the string value for the given key in the given context.
`static boolean` `getPreference​(String key, ICProject project, boolean defaultValue)` Returns the boolean value for the given key in the given context.
`static int` `getPreference​(String key, ICProject project, int defaultValue)` Returns the integer value for the given key in the given context.
`static String` `getPreference​(String key, ICProject project, String defaultValue)` Returns the string value for the given key in the given context.
`static String` `getPreference​(String key, org.eclipse.core.resources.IProject project)` Returns the string value for the given key in the given context.
`static boolean` `getPreference​(String key, org.eclipse.core.resources.IProject project, boolean defaultValue)` Returns the boolean value for the given key in the given context.
`static int` `getPreference​(String key, org.eclipse.core.resources.IProject project, int defaultValue)` Returns the integer value for the given key in the given context.
`static String` `getPreference​(String key, org.eclipse.core.resources.IProject project, String defaultValue)` Returns the string value for the given key in the given context.
`static org.eclipse.core.runtime.preferences.IScopeContext[]` `getPreferenceScopes​(org.eclipse.core.resources.IProject project)` Returns the scopes for preference lookup.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### TODO_TASK_TAGS

    public static final String TODO_TASK_TAGS

Task tags used in code comments.

See Also:
  Constant Field Values

#### DEFAULT_TASK_TAG

    public static final String DEFAULT_TASK_TAG

Default task tag

See Also:
  Constant Field Values

#### DEFAULT_TASK_TAGS

    public static final String DEFAULT_TASK_TAGS

List of tags provided by default

Since:
  5.1
See Also:
  Constant Field Values

#### TASK_PRIORITY_NORMAL

    public static final String TASK_PRIORITY_NORMAL

Possible configurable option value for TODO_TASK_PRIORITIES.

See Also:
  Constant Field Values

#### TASK_PRIORITY_HIGH

    public static final String TASK_PRIORITY_HIGH

Possible configurable option value for TODO_TASK_PRIORITIES.

See Also:
  Constant Field Values

#### TASK_PRIORITY_LOW

    public static final String TASK_PRIORITY_LOW

Possible configurable option value for TODO_TASK_PRIORITIES.

See Also:
  Constant Field Values

#### DEFAULT_TASK_PRIORITY

    public static final String DEFAULT_TASK_PRIORITY

Default task priority

See Also:
  Constant Field Values

#### TODO_TASK_PRIORITIES

    public static final String TODO_TASK_PRIORITIES

Priorities associated with task tags.

See Also:
  Constant Field Values

#### TODO_TASK_CASE_SENSITIVE

    public static final String TODO_TASK_CASE_SENSITIVE

Case sensitivity of task tags.

See Also:
  Constant Field Values

#### DEFAULT_TASK_CASE_SENSITIVE

    public static final String DEFAULT_TASK_CASE_SENSITIVE

Default case sensitivity of task tags.

See Also:
  Constant Field Values

#### CODE_FORMATTER

    public static final String CODE_FORMATTER

Active code formatter ID.

See Also:
  Constant Field Values

#### DEFAULT_CODE_FORMATTER

    public static final String DEFAULT_CODE_FORMATTER

Default code formatter

See Also:
  Constant Field Values

#### INDEX_DB_CACHE_SIZE_PCT

    public static final String INDEX_DB_CACHE_SIZE_PCT

Cache size for the index in percentage of max memory.

See Also:
  Constant Field Values

#### DEFAULT_INDEX_DB_CACHE_SIZE_PCT

    public static final String DEFAULT_INDEX_DB_CACHE_SIZE_PCT

Default cache size of the index-db in percentage of max memory.

See Also:
  Constant Field Values

#### MAX_INDEX_DB_CACHE_SIZE_MB

    public static final String MAX_INDEX_DB_CACHE_SIZE_MB

Absolute maximum size of the index-db in megabytes.

See Also:
  Constant Field Values

#### DEFAULT_MAX_INDEX_DB_CACHE_SIZE_MB

    public static final String DEFAULT_MAX_INDEX_DB_CACHE_SIZE_MB

Default absolute maximum size of the index-db in megabytes.

See Also:
  Constant Field Values

#### FILE_PATH_CANONICALIZATION

    public static final String FILE_PATH_CANONICALIZATION

Boolean preference controlling whether paths of non-workspace files are stored in index in canonical form or not. Canonicalization is performed by calling `File.getCanonicalPath()`.

Since:
  5.2
See Also:
  Constant Field Values

#### WORKSPACE_LANGUAGE_MAPPINGS

    public static final String WORKSPACE_LANGUAGE_MAPPINGS

Workspace-wide language mappings.

See Also:
  Constant Field Values

#### DEFAULT_WORKSPACE_LANGUAGE_MAPPINGS

    public static final String DEFAULT_WORKSPACE_LANGUAGE_MAPPINGS

Default workspace-wide language mappings.

See Also:
  Constant Field Values

#### SHOW_SOURCE_FILES_IN_BINARIES

    public static final String SHOW_SOURCE_FILES_IN_BINARIES

Attempt to show source files for executable binaries.

See Also:
  Constant Field Values

#### SHOW_SOURCE_NOT_FOUND_EDITOR

    public static final String SHOW_SOURCE_NOT_FOUND_EDITOR

Attempt to (not) show c source not found editor in debug. String value, one of `SHOW_SOURCE_NOT_FOUND_EDITOR_ALL_THE_TIME`, `SHOW_SOURCE_NOT_FOUND_EDITOR_SOMETIMES`, `SHOW_SOURCE_NOT_FOUND_EDITOR_NEVER`

Since:
  6.3
See Also:
  Constant Field Values

#### SHOW_SOURCE_NOT_FOUND_EDITOR_ALL_THE_TIME

    public static final String SHOW_SOURCE_NOT_FOUND_EDITOR_ALL_THE_TIME

Use to display all the time the source not found editor

Since:
  6.3
See Also:
  Constant Field Values

#### SHOW_SOURCE_NOT_FOUND_EDITOR_SOMETIMES

    public static final String SHOW_SOURCE_NOT_FOUND_EDITOR_SOMETIMES

Use to display sometimes the source not found editor

Since:
  6.3
See Also:
  Constant Field Values

#### SHOW_SOURCE_NOT_FOUND_EDITOR_NEVER

    public static final String SHOW_SOURCE_NOT_FOUND_EDITOR_NEVER

Use to don't display the source not found editor

Since:
  6.3
See Also:
  Constant Field Values

#### SHOW_SOURCE_NOT_FOUND_EDITOR_DEFAULT

    public static final String SHOW_SOURCE_NOT_FOUND_EDITOR_DEFAULT

Use to display by default the source not found editor

Since:
  6.3
See Also:
  Constant Field Values

#### SHOW_SOURCE_ROOTS_AT_TOP_LEVEL_OF_PROJECT

    public static final String SHOW_SOURCE_ROOTS_AT_TOP_LEVEL_OF_PROJECT

Show source roots at the top level of projects.

Since:
  5.2
See Also:
  Constant Field Values

#### PREF_BUILD_ALL_CONFIGS

    public static final String PREF_BUILD_ALL_CONFIGS

"Build All Configurations" preference key.

Since:
  5.3
See Also:
  Constant Field Values

#### PREF_BUILD_CONFIGS_RESOURCE_CHANGES

    public static final String PREF_BUILD_CONFIGS_RESOURCE_CHANGES

Preference key for "build only if resources in (related) projects are modified".

Since:
  5.3
See Also:
  Constant Field Values

#### DEFAULT_INCLUDE_EXPORT_PATTERN

    public static final String DEFAULT_INCLUDE_EXPORT_PATTERN

Default value for `INCLUDE_EXPORT_PATTERN`.

Since:
  5.5
See Also:
  Constant Field Values

#### INCLUDE_EXPORT_PATTERN

    public static final String INCLUDE_EXPORT_PATTERN

Preference key for the regular expression pattern that, when appears in a comment on the same line as include statement, indicates that the included header file is exported.

Since:
  5.5
See Also:
  "https://github.com/include-what-you-use/include-what-you-use/blob/master/docs/IWYUPragmas.md", Constant Field Values

#### DEFAULT_INCLUDE_BEGIN_EXPORTS_PATTERN

    public static final String DEFAULT_INCLUDE_BEGIN_EXPORTS_PATTERN

Default value for `INCLUDE_BEGIN_EXPORTS_PATTERN`.

Since:
  5.5
See Also:
  Constant Field Values

#### INCLUDE_BEGIN_EXPORTS_PATTERN

    public static final String INCLUDE_BEGIN_EXPORTS_PATTERN

Preference key for the regular expression pattern that, when appears in a comment, marks the beginning of a sequence of include statements that export the included header files.

Since:
  5.5
See Also:
  "https://github.com/include-what-you-use/include-what-you-use/blob/master/docs/IWYUPragmas.md", Constant Field Values

#### DEFAULT_INCLUDE_END_EXPORTS_PATTERN

    public static final String DEFAULT_INCLUDE_END_EXPORTS_PATTERN

Default value for `INCLUDE_END_EXPORTS_PATTERN`.

Since:
  5.5
See Also:
  Constant Field Values

#### INCLUDE_END_EXPORTS_PATTERN

    public static final String INCLUDE_END_EXPORTS_PATTERN

Preference key for the regular expression pattern that, when appears in a comment, marks the end of a sequence of include statements that export the included header files.

Since:
  5.5
See Also:
  "https://github.com/include-what-you-use/include-what-you-use/blob/master/docs/IWYUPragmas.md", Constant Field Values

#### DEFAULT_INCLUDE_PRIVATE_PATTERN

    public static final String DEFAULT_INCLUDE_PRIVATE_PATTERN

Default value for `INCLUDE_PRIVATE_PATTERN`.

Since:
  5.7
See Also:
  Constant Field Values

#### INCLUDE_PRIVATE_PATTERN

    public static final String INCLUDE_PRIVATE_PATTERN

Preference key for the regular expression pattern that, when appears in a comment on the same line as include statement, indicates that the included header file is private and that another header file should be included instead.

Since:
  5.7
See Also:
  "https://github.com/include-what-you-use/include-what-you-use/blob/master/docs/IWYUPragmas.md", Constant Field Values

#### DEFAULT_INCLUDE_KEEP_PATTERN

    public static final String DEFAULT_INCLUDE_KEEP_PATTERN

Default value for `INCLUDE_KEEP_PATTERN`.

Since:
  5.9
See Also:
  Constant Field Values

#### INCLUDE_KEEP_PATTERN

    public static final String INCLUDE_KEEP_PATTERN

Preference key for the regular expression pattern that, when appears in a comment on the same line as include statement, indicates that the include statement should be preserved when organizing includes.

Since:
  5.9
See Also:
  "https://github.com/include-what-you-use/include-what-you-use/blob/master/docs/IWYUPragmas.md", Constant Field Values

#### SCALABILITY_SKIP_TRIVIAL_EXPRESSIONS

    public static String SCALABILITY_SKIP_TRIVIAL_EXPRESSIONS

A named preference that controls whether the parser should skip trivial expressions in initializer lists.

Value is of type `Boolean`.

Since:
  5.6

#### DEFAULT_SCALABILITY_SKIP_TRIVIAL_EXPRESSIONS

    public static final boolean DEFAULT_SCALABILITY_SKIP_TRIVIAL_EXPRESSIONS

Default value for `SCALABILITY_SKIP_TRIVIAL_EXPRESSIONS`.

Since:
  5.6
See Also:
  Constant Field Values

#### SCALABILITY_MAXIMUM_TRIVIAL_EXPRESSIONS

    public static final String SCALABILITY_MAXIMUM_TRIVIAL_EXPRESSIONS

The maximum number of trivial expressions that are parsed in initializer lists. This preference is considered only if `SCALABILITY_SKIP_TRIVIAL_EXPRESSIONS` is set to true.

Value is of type `int`.

Since:
  5.6
See Also:
  Constant Field Values

#### DEFAULT_SCALABILITY_MAXIMUM_TRIVIAL_EXPRESSIONS

    public static final int DEFAULT_SCALABILITY_MAXIMUM_TRIVIAL_EXPRESSIONS

Default value for `SCALABILITY_MAXIMUM_TRIVIAL_EXPRESSIONS`.

Since:
  5.6
See Also:
  Constant Field Values

#### SCALABILITY_LIMIT_TOKENS_PER_TU

    public static final String SCALABILITY_LIMIT_TOKENS_PER_TU

A named preference that specifies whether the parser should abort when too many Tokens are created during parse of a single TU. This is a heuristic that is used to detect translation units that are too complex to be handled the by the CDT parser.

Since:
  5.7
See Also:
  Constant Field Values

#### DEFAULT_SCALABILITY_LIMIT_TOKENS_PER_TU

    public static final boolean DEFAULT_SCALABILITY_LIMIT_TOKENS_PER_TU

Default value for `SCALABILITY_LIMIT_TOKENS_PER_TU`.

Since:
  5.7
See Also:
  Constant Field Values

#### SCALABILITY_MAXIMUM_TOKENS

    public static final String SCALABILITY_MAXIMUM_TOKENS

A named preference that specifies the parser's token limit. Parsing will be aborted when a single translation unit has produced a maximum number of tokens. This is a heuristic that is used to detect translation units that are too complex to be handled the by the CDT parser.

Since:
  5.7
See Also:
  Constant Field Values

#### DEFAULT_SCALABILITY_MAXIMUM_TOKENS

    public static final int DEFAULT_SCALABILITY_MAXIMUM_TOKENS

Default value for `SCALABILITY_MAXIMUM_TOKENS`.

Since:
  5.7
See Also:
  Constant Field Values

#### PLACE_CONST_RIGHT_OF_TYPE

    public static final String PLACE_CONST_RIGHT_OF_TYPE

A named preference that specifies whether the const qualifier is written to the right (or left) of the type in a declaration specifier.

Since:
  6.3
See Also:
  Constant Field Values

#### DEFAULT_PLACE_CONST_RIGHT_OF_TYPE

    public static final boolean DEFAULT_PLACE_CONST_RIGHT_OF_TYPE

Default value for `PLACE_CONST_RIGHT_OF_TYPE`.

Since:
  6.3
See Also:
  Constant Field Values

#### ADD_OVERRIDE_KEYWORD

    public static final String ADD_OVERRIDE_KEYWORD

A named preference that specifies whether the override keyword should be added to method signature.

Since:
  6.8
See Also:
  Constant Field Values

#### PRESERVE_VIRTUAL_KEYWORD

    public static final String PRESERVE_VIRTUAL_KEYWORD

A named preference that specifies whether the virtual keyword should be added to method signature.

Since:
  6.8
See Also:
  Constant Field Values

#### DEFAULT_ADD_OVERRIDE_KEYWORD

    public static final boolean DEFAULT_ADD_OVERRIDE_KEYWORD

Default value for `ADD_OVERRIDE_KEYWORD`.

Since:
  6.8
See Also:
  Constant Field Values

#### DEFAULT_PRESERVE_VIRTUAL_KEYWORD

    public static final boolean DEFAULT_PRESERVE_VIRTUAL_KEYWORD

Default value for `PRESERVE_VIRTUAL_KEYWORD`.

Since:
  6.8
See Also:
  Constant Field Values

### Constructor Detail

#### CCorePreferenceConstants

    public CCorePreferenceConstants()

### Method Detail

#### getPreference

    public static String getPreference​(String key,
                                       ICProject project)

Returns the string value for the given key in the given context.

Parameters:
  `key` - The preference key
  `project` - The current context or `null` if no context is available and the workspace setting should be taken. Note that passing `null` should be avoided.
Returns:
  Returns the current value for the string.
Since:
  5.5

#### getPreference

    public static String getPreference​(String key,
                                       org.eclipse.core.resources.IProject project)

Returns the string value for the given key in the given context.

Parameters:
  `key` - The preference key
  `project` - The current context or `null` if no context is available and the workspace setting should be taken. Note that passing `null` should be avoided.
Returns:
  Returns the current value for the string.
Since:
  5.9

#### getPreference

    public static String getPreference​(String key,
                                       ICProject project,
                                       String defaultValue)

Returns the string value for the given key in the given context.

Parameters:
  `key` - The preference key
  `project` - The current context or `null` if no context is available and the workspace setting should be taken. Note that passing `null` should be avoided.
  `defaultValue` - The default value if not specified in the preferences.
Returns:
  Returns the current value of the preference.
Since:
  5.5

#### getPreference

    public static String getPreference​(String key,
                                       org.eclipse.core.resources.IProject project,
                                       String defaultValue)

Returns the string value for the given key in the given context.

Parameters:
  `key` - The preference key
  `project` - The current context or `null` if no context is available and the workspace setting should be taken. Note that passing `null` should be avoided.
  `defaultValue` - The default value if not specified in the preferences.
Returns:
  Returns the current value of the preference.
Since:
  5.9

#### getPreference

    public static int getPreference​(String key,
                                    ICProject project,
                                    int defaultValue)

Returns the integer value for the given key in the given context.

Parameters:
  `key` - The preference key
  `project` - The current context or `null` if no context is available and the workspace setting should be taken. Note that passing `null` should be avoided.
  `defaultValue` - The default value if not specified in the preferences.
Returns:
  Returns the current value of the preference.
Since:
  5.5

#### getPreference

    public static int getPreference​(String key,
                                    org.eclipse.core.resources.IProject project,
                                    int defaultValue)

Returns the integer value for the given key in the given context.

Parameters:
  `key` - The preference key
  `project` - The current context or `null` if no context is available and the workspace setting should be taken. Note that passing `null` should be avoided.
  `defaultValue` - The default value if not specified in the preferences.
Returns:
  Returns the current value of the preference.
Since:
  5.9

#### getPreference

    public static boolean getPreference​(String key,
                                        ICProject project,
                                        boolean defaultValue)

Returns the boolean value for the given key in the given context.

Parameters:
  `key` - The preference key
  `project` - The current context or `null` if no context is available and the workspace setting should be taken. Note that passing `null` should be avoided.
  `defaultValue` - The default value if not specified in the preferences.
Returns:
  Returns the current value of the preference.
Since:
  5.5

#### getPreference

    public static boolean getPreference​(String key,
                                        org.eclipse.core.resources.IProject project,
                                        boolean defaultValue)

Returns the boolean value for the given key in the given context.

Parameters:
  `key` - The preference key
  `project` - The current context or `null` if no context is available and the workspace setting should be taken. Note that passing `null` should be avoided.
  `defaultValue` - The default value if not specified in the preferences.
Returns:
  Returns the current value of the preference.
Since:
  5.9

#### getPreferenceScopes

    public static org.eclipse.core.runtime.preferences.IScopeContext[] getPreferenceScopes​(org.eclipse.core.resources.IProject project)

Returns the scopes for preference lookup.

Parameters:
  `project` - a project or `null`
Returns:
  the scopes for preference lookup.
Since:
  5.5